diff --git a/libcfs/include/libcfs/linux/kp30.h b/libcfs/include/libcfs/linux/kp30.h
index ff19b55..3c50da4 100644
--- a/libcfs/include/libcfs/linux/kp30.h
+++ b/libcfs/include/libcfs/linux/kp30.h
@@ -111,7 +111,9 @@ do {                                                                          \
 #define LASSERT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #define LINVRNT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #endif
+
 #define LASSERT_SEM_LOCKED(sem) LASSERT(down_trylock(sem) != 0)
+#define LASSERT_MUTEX_LOCKED(x) LASSERT(mutex_is_locked(x))
 
 #ifdef HAVE_SEM_COUNT_ATOMIC
 #define SEM_COUNT(sem)          (atomic_read(&(sem)->count))
diff --git a/libcfs/include/libcfs/linux/linux-lock.h b/libcfs/include/libcfs/linux/linux-lock.h
index e3a8e66..84f4253 100644
--- a/libcfs/include/libcfs/linux/linux-lock.h
+++ b/libcfs/include/libcfs/linux/linux-lock.h
@@ -119,7 +119,6 @@ typedef spinlock_t cfs_spinlock_t;
  */
 typedef struct rw_semaphore cfs_rw_semaphore_t;
 
-#define cfs_sema_init(s, val)     sema_init(s, val)
 #define cfs_init_rwsem(s)         init_rwsem(s)
 #define cfs_down_read(s)          down_read(s)
 #define cfs_down_read_trylock(s)  down_read_trylock(s)
@@ -133,11 +132,6 @@ typedef struct rw_semaphore cfs_rw_semaphore_t;
 #define CFS_DECLARE_RWSEM(name)   DECLARE_RWSEM(name)
 
 /*
- * semaphore "implementation" (use Linux kernel's primitives)
- */
-typedef struct semaphore      cfs_semaphore_t;
-
-/*
  * rwlock_t "implementation" (use Linux kernel's primitives)
  *
  * - rwlock_init(x)
@@ -190,69 +184,50 @@ typedef struct completion cfs_completion_t;
 #define cfs_fini_completion(c)                   do { } while (0)
 
 /*
+ * semaphore "implementation" (use Linux kernel's primitives)
+ * - DEFINE_SEMAPHORE(name)
+ * - sema_init(sem, val)
+ * - up(sem)
+ * - down(sem)
+ * - down_interruptible(sem)
+ * - down_trylock(sem)
+ */
+typedef struct semaphore      cfs_semaphore_t;
+
+#ifdef DEFINE_SEMAPHORE
+#define CFS_DEFINE_SEMAPHORE(name)          DEFINE_SEMAPHORE(name)
+#else
+#define CFS_DEFINE_SEMAPHORE(name)          DECLARE_MUTEX(name)
+#endif
+
+#define cfs_sema_init(sem, val)             sema_init(sem, val)
+#define cfs_up(x)                           up(x)
+#define cfs_down(x)                         down(x)
+#define cfs_down_interruptible(x)           down_interruptible(x)
+#define cfs_down_trylock(x)                 down_trylock(x)
+
+/*
  * mutex "implementation" (use Linux kernel's primitives)
  *
- * - DECLARE_MUTEX(name)
+ * - DEFINE_MUTEX(name)
  * - mutex_init(x)
- * - init_mutex(x)
- * - init_mutex_locked(x)
- * - init_MUTEX_LOCKED(x)
- * - mutex_up(x)
- * - mutex_down(x)
- * - up(x)
- * - down(x)
- * - mutex_down_trylock(x)
  * - mutex_lock(x)
  * - mutex_unlock(x)
+ * - mutex_trylock(x)
+ * - mutex_is_locked(x)
+ * - mutex_destroy(x)
  */
 typedef struct mutex cfs_mutex_t;
 
 #define CFS_DEFINE_MUTEX(name)             DEFINE_MUTEX(name)
-#define CFS_DECLARE_MUTEX(name)            DECLARE_MUTEX(name)
 
 #define cfs_mutex_init(x)                   mutex_init(x)
-#define cfs_init_mutex(x)                   init_MUTEX(x)
-#define cfs_init_mutex_locked(x)            init_MUTEX_LOCKED(x)
-#define cfs_mutex_up(x)                     up(x)
-#define cfs_mutex_down(x)                   down(x)
-#define cfs_up(x)                           up(x)
-#define cfs_down(x)                         down(x)
-#define cfs_down_interruptible(x)           down_interruptible(x)
-#define cfs_mutex_down_trylock(x)           down_trylock(x)
 #define cfs_mutex_lock(x)                   mutex_lock(x)
 #define cfs_mutex_unlock(x)                 mutex_unlock(x)
+#define cfs_mutex_lock_interruptible(x)     mutex_lock_interruptible(x)
 #define cfs_mutex_trylock(x)                mutex_trylock(x)
-
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
-
-/**************************************************************************
- *
- * Mutex interface from newer Linux kernels.
- *
- * this augments compatibility interface from include/linux/mutex.h
- *
- **************************************************************************/
-
-static inline void cfs_mutex_destroy(cfs_mutex_t *lock)
-{
-}
-
-/*
- * This is for use in assertions _only_, i.e., this function should always
- * return 1.
- *
- * \retval 1 mutex is locked.
- *
- * \retval 0 mutex is not locked. This should never happen.
- */
-static inline int cfs_mutex_is_locked(cfs_mutex_t *lock)
-{
-        return 1;
-}
-#else /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16) */
-#define cfs_mutex_destroy(x)    mutex_destroy(x)
-#define cfs_mutex_is_locked(x)  mutex_is_locked(x)
-#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16) */
+#define cfs_mutex_is_locked(x)              mutex_is_locked(x)
+#define cfs_mutex_destroy(x)                mutex_destroy(x)
 
 /*
  * Kernel locking primitives
diff --git a/libcfs/include/libcfs/user-lock.h b/libcfs/include/libcfs/user-lock.h
index 8c70f05..7228d83 100644
--- a/libcfs/include/libcfs/user-lock.h
+++ b/libcfs/include/libcfs/user-lock.h
@@ -92,6 +92,7 @@ typedef struct cfs_spin_lock cfs_spinlock_t;
 #define LASSERT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #define LINVRNT_SPIN_LOCKED(lock) do {(void)sizeof(lock);} while(0)
 #define LASSERT_SEM_LOCKED(sem) do {(void)sizeof(sem);} while(0)
+#define LASSERT_MUTEX_LOCKED(x) do {(void)sizeof(x);} while(0)
 
 void cfs_spin_lock_init(cfs_spinlock_t *lock);
 void cfs_spin_lock(cfs_spinlock_t *lock);
@@ -118,8 +119,20 @@ typedef struct cfs_semaphore {
 } cfs_semaphore_t;
 
 void cfs_sema_init(cfs_semaphore_t *s, int val);
-void __down(cfs_semaphore_t *s);
 void __up(cfs_semaphore_t *s);
+void __down(cfs_semaphore_t *s);
+int __down_interruptible(cfs_semaphore_t *s);
+
+#define CFS_DEFINE_SEMAPHORE(name)      cfs_semaphore_t name = { 1 }
+
+#define cfs_up(s)                       __up(s)
+#define cfs_down(s)                     __down(s)
+#define cfs_down_interruptible(s)       __down_interruptible(s)
+
+static inline int cfs_down_trylock(cfs_semaphore_t *sem)
+{
+        return 0;
+}
 
 /*
  * Completion:
@@ -275,50 +288,28 @@ void cfs_mt_atomic_sub(int b, cfs_mt_atomic_t *a);
  * Mutex interface.
  *
  **************************************************************************/
-#define CFS_DECLARE_MUTEX(name)     \
-        cfs_semaphore_t name = { 1 }
-
-#define cfs_mutex_up(s)                     __up(s)
-#define cfs_up(s)                           cfs_mutex_up(s)
-#define cfs_mutex_down(s)                   __down(s)
-#define cfs_down(s)                         cfs_mutex_down(s)
-#define cfs_mutex_down_interruptible(s)     __down_interruptible(s)
-#define cfs_down_interruptible(s)           cfs_mutex_down_interruptible(s)
+typedef struct cfs_semaphore cfs_mutex_t;
 
-#define cfs_init_mutex(x)                   cfs_sema_init(x, 1)
-#define cfs_init_mutex_locked(x)            cfs_sema_init(x, 0)
-
-typedef struct cfs_mutex {
-        cfs_semaphore_t m_sem;
-} cfs_mutex_t;
-
-#define CFS_DEFINE_MUTEX(m) cfs_mutex_t m
+#define CFS_DEFINE_MUTEX(m) CFS_DEFINE_SEMAPHORE(m)
 
 static inline void cfs_mutex_init(cfs_mutex_t *mutex)
 {
-        cfs_init_mutex(&mutex->m_sem);
+        cfs_sema_init(mutex, 1);
 }
 
 static inline void cfs_mutex_lock(cfs_mutex_t *mutex)
 {
-        cfs_mutex_down(&mutex->m_sem);
+        cfs_down(mutex);
 }
 
 static inline void cfs_mutex_unlock(cfs_mutex_t *mutex)
 {
-        cfs_mutex_up(&mutex->m_sem);
+        cfs_up(mutex);
 }
 
-/**
- * Try-lock this mutex.
- *
- *
- * \retval 0 try-lock succeeded (lock acquired).
- * \retval errno indicates lock contention.
- */
-static inline int cfs_mutex_down_trylock(cfs_mutex_t *mutex)
+static inline int cfs_mutex_lock_interruptible(cfs_mutex_t *mutex)
 {
-        return 0;
+        return cfs_down_interruptible(mutex);
 }
 
 /**
@@ -332,7 +323,7 @@ static inline int cfs_mutex_down_trylock(cfs_mutex_t *mutex)
  */
 static inline int cfs_mutex_trylock(cfs_mutex_t *mutex)
 {
-        return !cfs_mutex_down_trylock(mutex);
+        return !cfs_down_trylock(mutex);
 }
 
 static inline void cfs_mutex_destroy(cfs_mutex_t *lock)
diff --git a/libcfs/libcfs/module.c b/libcfs/libcfs/module.c
index 8278b4c..d66950f 100644
--- a/libcfs/libcfs/module.c
+++ b/libcfs/libcfs/module.c
@@ -370,7 +370,7 @@ MODULE_LICENSE("GPL");
 
 extern cfs_psdev_t libcfs_dev;
 extern cfs_rw_semaphore_t cfs_tracefile_sem;
-extern cfs_semaphore_t cfs_trace_thread_sem;
+extern cfs_mutex_t cfs_trace_thread_mutex;
 
 extern void libcfs_init_nidstrings(void);
 extern int libcfs_arch_init(void);
@@ -383,7 +383,7 @@ static int init_libcfs_module(void)
         libcfs_arch_init();
         libcfs_init_nidstrings();
         cfs_init_rwsem(&cfs_tracefile_sem);
-        cfs_init_mutex(&cfs_trace_thread_sem);
+        cfs_mutex_init(&cfs_trace_thread_mutex);
         cfs_init_rwsem(&ioctl_list_sem);
         CFS_INIT_LIST_HEAD(&ioctl_list);
         cfs_waitq_init(&cfs_race_waitq);
diff --git a/libcfs/libcfs/tracefile.c b/libcfs/libcfs/tracefile.c
index d681fc3..cb14b0c 100644
--- a/libcfs/libcfs/tracefile.c
+++ b/libcfs/libcfs/tracefile.c
@@ -52,7 +52,7 @@ union cfs_trace_data_union (*cfs_trace_data[TCD_MAX_TYPES])[CFS_NR_CPUS] __cache
 char cfs_tracefile[TRACEFILE_NAME_SIZE];
 long long cfs_tracefile_size = CFS_TRACEFILE_SIZE;
 static struct tracefiled_ctl trace_tctl;
-cfs_semaphore_t cfs_trace_thread_sem;
+cfs_mutex_t cfs_trace_thread_mutex;
 static int thread_running = 0;
 
 cfs_atomic_t cfs_tage_allocated = CFS_ATOMIC_INIT(0);
@@ -1087,7 +1087,7 @@ int cfs_trace_start_thread(void)
         struct tracefiled_ctl *tctl = &trace_tctl;
         int rc = 0;
 
-        cfs_mutex_down(&cfs_trace_thread_sem);
+        cfs_mutex_lock(&cfs_trace_thread_mutex);
         if (thread_running)
                 goto out;
 
@@ -1104,7 +1104,7 @@ int cfs_trace_start_thread(void)
         cfs_wait_for_completion(&tctl->tctl_start);
         thread_running = 1;
 out:
-        cfs_mutex_up(&cfs_trace_thread_sem);
+        cfs_mutex_unlock(&cfs_trace_thread_mutex);
         return rc;
 }
 
@@ -1112,7 +1112,7 @@ void cfs_trace_stop_thread(void)
 {
         struct tracefiled_ctl *tctl = &trace_tctl;
 
-        cfs_mutex_down(&cfs_trace_thread_sem);
+        cfs_mutex_lock(&cfs_trace_thread_mutex);
         if (thread_running) {
                 printk(CFS_KERN_INFO
                        "Lustre: shutting down debug daemon thread...\n");
@@ -1120,7 +1120,7 @@ void cfs_trace_stop_thread(void)
                 cfs_wait_for_completion(&tctl->tctl_stop);
                 thread_running = 0;
         }
-        cfs_mutex_up(&cfs_trace_thread_sem);
+        cfs_mutex_unlock(&cfs_trace_thread_mutex);
 }
 
 int cfs_tracefile_init(int max_pages)
diff --git a/libcfs/libcfs/watchdog.c b/libcfs/libcfs/watchdog.c
index b9f488f..58a3043 100644
--- a/libcfs/libcfs/watchdog.c
+++ b/libcfs/libcfs/watchdog.c
@@ -86,7 +86,7 @@ static unsigned long lcw_flags = 0;
  * When it hits 0, we stop the dispatcher.
  */
 static __u32         lcw_refcount = 0;
-static CFS_DECLARE_MUTEX(lcw_refcount_sem);
+static CFS_DEFINE_MUTEX(lcw_refcount_mutex);
 
 /*
  * List of timers that have fired that need their callbacks run by the
@@ -379,10 +379,10 @@ struct lc_watchdog *lc_watchdog_add(int timeout,
         CFS_INIT_LIST_HEAD(&lcw->lcw_list);
         cfs_timer_init(&lcw->lcw_timer, lcw_cb, lcw);
 
-        cfs_down(&lcw_refcount_sem);
+        cfs_mutex_lock(&lcw_refcount_mutex);
         if (++lcw_refcount == 1)
                 lcw_dispatch_start();
-        cfs_up(&lcw_refcount_sem);
+        cfs_mutex_unlock(&lcw_refcount_mutex);
 
         /* Keep this working in case we enable them by default */
         if (lcw->lcw_state == LC_WATCHDOG_ENABLED) {
@@ -487,10 +487,10 @@ void lc_watchdog_delete(struct lc_watchdog *lcw)
         if (dead)
                 LIBCFS_FREE(lcw, sizeof(*lcw));
 
-        cfs_down(&lcw_refcount_sem);
+        cfs_mutex_lock(&lcw_refcount_mutex);
         if (--lcw_refcount == 0)
                 lcw_dispatch_stop();
-        cfs_up(&lcw_refcount_sem);
+        cfs_mutex_unlock(&lcw_refcount_mutex);
 
         EXIT;
 }
diff --git a/lnet/include/lnet/lib-lnet.h b/lnet/include/lnet/lib-lnet.h
index 33f780d..271d84b 100644
--- a/lnet/include/lnet/lib-lnet.h
+++ b/lnet/include/lnet/lib-lnet.h
@@ -98,8 +98,8 @@ lnet_match_to_hash(lnet_process_id_t id, __u64 mbits)
 #ifdef __KERNEL__
 #define LNET_LOCK()        cfs_spin_lock(&the_lnet.ln_lock)
 #define LNET_UNLOCK()      cfs_spin_unlock(&the_lnet.ln_lock)
-#define LNET_MUTEX_DOWN(m) cfs_mutex_down(m)
-#define LNET_MUTEX_UP(m)   cfs_mutex_up(m)
+#define LNET_MUTEX_LOCK(m)   cfs_mutex_lock(m)
+#define LNET_MUTEX_UNLOCK(m) cfs_mutex_unlock(m)
 #else
 # ifndef HAVE_LIBPTHREAD
 #define LNET_SINGLE_THREADED_LOCK(l)            \
@@ -116,13 +116,13 @@ do {                                            \
 
 #define LNET_LOCK()        LNET_SINGLE_THREADED_LOCK(the_lnet.ln_lock)
 #define LNET_UNLOCK()      LNET_SINGLE_THREADED_UNLOCK(the_lnet.ln_lock)
-#define LNET_MUTEX_DOWN(m) LNET_SINGLE_THREADED_LOCK(*(m))
-#define LNET_MUTEX_UP(m)   LNET_SINGLE_THREADED_UNLOCK(*(m))
+#define LNET_MUTEX_LOCK(m)     LNET_SINGLE_THREADED_LOCK(*(m))
+#define LNET_MUTEX_UNLOCK(m)   LNET_SINGLE_THREADED_UNLOCK(*(m))
 # else
 #define LNET_LOCK()        pthread_mutex_lock(&the_lnet.ln_lock)
 #define LNET_UNLOCK()      pthread_mutex_unlock(&the_lnet.ln_lock)
-#define LNET_MUTEX_DOWN(m) pthread_mutex_lock(m)
-#define LNET_MUTEX_UP(m)   pthread_mutex_unlock(m)
+#define LNET_MUTEX_LOCK(m)     pthread_mutex_lock(m)
+#define LNET_MUTEX_UNLOCK(m)   pthread_mutex_unlock(m)
 # endif
 #endif
 
diff --git a/lnet/include/lnet/lib-types.h b/lnet/include/lnet/lib-types.h
index 73aa5db..946f669 100644
--- a/lnet/include/lnet/lib-types.h
+++ b/lnet/include/lnet/lib-types.h
@@ -542,8 +542,8 @@ typedef struct
 #ifdef __KERNEL__
         cfs_spinlock_t         ln_lock;
         cfs_waitq_t            ln_waitq;
-        cfs_semaphore_t   ln_api_mutex;
-        cfs_semaphore_t   ln_lnd_mutex;
+        cfs_mutex_t            ln_api_mutex;
+        cfs_mutex_t            ln_lnd_mutex;
 #else
 # ifndef HAVE_LIBPTHREAD
         int                    ln_lock;
@@ -608,12 +608,12 @@ typedef struct
         lnet_ping_info_t      *ln_ping_info;
 
 #ifdef __KERNEL__
-        cfs_semaphore_t   ln_rc_signal;        /* serialise startup/shutdown */
+        cfs_semaphore_t        ln_rc_signal;        /* serialise startup/shutdown */
 #endif
-        int                ln_rc_state;         /* router checker startup/shutdown state */
-        lnet_handle_eq_t   ln_rc_eqh;           /* router checker's event queue */
-        lnet_handle_md_t   ln_rc_mdh;
-        cfs_list_t         ln_zombie_rcd;
+        int                    ln_rc_state;         /* router checker startup/shutdown state */
+        lnet_handle_eq_t       ln_rc_eqh;           /* router checker's event queue */
+        lnet_handle_md_t       ln_rc_mdh;
+        cfs_list_t             ln_zombie_rcd;
 
 #ifdef LNET_USE_LIB_FREELIST
         lnet_freelist_t        ln_free_mes;
diff --git a/lnet/klnds/mxlnd/mxlnd_cb.c b/lnet/klnds/mxlnd/mxlnd_cb.c
index 057a34d..3ce4c6e 100644
--- a/lnet/klnds/mxlnd/mxlnd_cb.c
+++ b/lnet/klnds/mxlnd/mxlnd_cb.c
@@ -2557,7 +2557,7 @@ mxlnd_tx_queued(void *arg)
         cfs_daemonize("mxlnd_tx_queued");
 
         while (!(cfs_atomic_read(&kmxlnd_data.kmx_shutdown))) {
-                ret = down_interruptible(&kmxlnd_data.kmx_tx_queue_sem);
+                ret = cfs_down_interruptible(&kmxlnd_data.kmx_tx_queue_sem);
                 if (cfs_atomic_read(&kmxlnd_data.kmx_shutdown))
                         break;
                 if (ret != 0) // Should we check for -EINTR?
@@ -3972,7 +3972,7 @@ mxlnd_connd(void *arg)
                 cfs_spinlock_t    *g_conn_lock     = &kmxlnd_data.kmx_conn_lock;
                 cfs_list_t        *conn_reqs       = &kmxlnd_data.kmx_conn_reqs;
 
-                ret = down_interruptible(&kmxlnd_data.kmx_conn_sem);
+                ret = cfs_down_interruptible(&kmxlnd_data.kmx_conn_sem);
 
                 if (cfs_atomic_read(&kmxlnd_data.kmx_shutdown))
                         break;
diff --git a/lnet/klnds/ptllnd/ptllnd_ptltrace.c b/lnet/klnds/ptllnd/ptllnd_ptltrace.c
index a94bebb..20fdc96 100644
--- a/lnet/klnds/ptllnd/ptllnd_ptltrace.c
+++ b/lnet/klnds/ptllnd/ptllnd_ptltrace.c
@@ -37,7 +37,7 @@
 #include "ptllnd.h"
 
 #ifdef CRAY_XT3
-static cfs_semaphore_t    ptltrace_mutex;
+static cfs_mutex_t        ptltrace_mutex;
 static cfs_waitq_t        ptltrace_debug_ctlwq;
 
 void
@@ -139,7 +139,7 @@ kptllnd_dump_ptltrace_thread(void *arg)
         libcfs_daemonize("kpt_ptltrace_dump");
 
         /* serialise with other instances of me */
-        cfs_mutex_down(&ptltrace_mutex);
+        cfs_mutex_lock(&ptltrace_mutex);
 
         snprintf(fname, sizeof(fname), "%s.%ld.%ld",
                  *kptllnd_tunables.kptl_ptltrace_basename,
@@ -147,7 +147,7 @@ kptllnd_dump_ptltrace_thread(void *arg)
 
         kptllnd_ptltrace_to_file(fname);
 
-        cfs_mutex_up(&ptltrace_mutex);
+        cfs_mutex_unlock(&ptltrace_mutex);
 
         /* unblock my creator */
         cfs_waitq_signal(&ptltrace_debug_ctlwq);
@@ -185,6 +185,6 @@ void
 kptllnd_init_ptltrace(void)
 {
         cfs_waitq_init(&ptltrace_debug_ctlwq);
-        cfs_init_mutex(&ptltrace_mutex);
+        cfs_mutex_init(&ptltrace_mutex);
 }
 #endif
diff --git a/lnet/lnet/api-ni.c b/lnet/lnet/api-ni.c
index fc25673..c5cb3f4 100644
--- a/lnet/lnet/api-ni.c
+++ b/lnet/lnet/api-ni.c
@@ -93,8 +93,8 @@ lnet_init_locks(void)
 {
         cfs_spin_lock_init (&the_lnet.ln_lock);
         cfs_waitq_init (&the_lnet.ln_waitq);
-        cfs_init_mutex(&the_lnet.ln_lnd_mutex);
-        cfs_init_mutex(&the_lnet.ln_api_mutex);
+        cfs_mutex_init(&the_lnet.ln_lnd_mutex);
+        cfs_mutex_init(&the_lnet.ln_api_mutex);
 }
 
 void
@@ -319,7 +319,7 @@ lnet_find_lnd_by_type (int type)
 void
 lnet_register_lnd (lnd_t *lnd)
 {
-        LNET_MUTEX_DOWN(&the_lnet.ln_lnd_mutex);
+        LNET_MUTEX_LOCK(&the_lnet.ln_lnd_mutex);
 
         LASSERT (the_lnet.ln_init);
         LASSERT (libcfs_isknown_lnd(lnd->lnd_type));
@@ -330,13 +330,13 @@ lnet_register_lnd (lnd_t *lnd)
 
         CDEBUG(D_NET, "%s LND registered\n", libcfs_lnd2str(lnd->lnd_type));
 
-        LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+        LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
 }
 
 void
 lnet_unregister_lnd (lnd_t *lnd)
 {
-        LNET_MUTEX_DOWN(&the_lnet.ln_lnd_mutex);
+        LNET_MUTEX_LOCK(&the_lnet.ln_lnd_mutex);
 
         LASSERT (the_lnet.ln_init);
         LASSERT (lnet_find_lnd_by_type(lnd->lnd_type) == lnd);
@@ -345,7 +345,7 @@ lnet_unregister_lnd (lnd_t *lnd)
         cfs_list_del (&lnd->lnd_list);
         CDEBUG(D_NET, "%s LND unregistered\n", libcfs_lnd2str(lnd->lnd_type));
 
-        LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+        LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
 }
 
 #ifndef LNET_USE_LIB_FREELIST
@@ -1037,19 +1037,19 @@ lnet_startup_lndnis (void)
                         goto failed;
                 }
 
-                LNET_MUTEX_DOWN(&the_lnet.ln_lnd_mutex);
+                LNET_MUTEX_LOCK(&the_lnet.ln_lnd_mutex);
                 lnd = lnet_find_lnd_by_type(lnd_type);
 
 #ifdef __KERNEL__
                 if (lnd == NULL) {
-                        LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+                        LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
                         rc = cfs_request_module("%s",
                                                 libcfs_lnd2modname(lnd_type));
-                        LNET_MUTEX_DOWN(&the_lnet.ln_lnd_mutex);
+                        LNET_MUTEX_LOCK(&the_lnet.ln_lnd_mutex);
 
                         lnd = lnet_find_lnd_by_type(lnd_type);
                         if (lnd == NULL) {
-                                LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+                                LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
                                 CERROR("Can't load LND %s, module %s, rc=%d\n",
                                        libcfs_lnd2str(lnd_type),
                                        libcfs_lnd2modname(lnd_type), rc);
@@ -1063,7 +1063,7 @@ lnet_startup_lndnis (void)
                 }
 #else
                 if (lnd == NULL) {
-                        LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+                        LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
                         CERROR("LND %s not supported\n",
                                libcfs_lnd2str(lnd_type));
                         goto failed;
@@ -1080,7 +1080,7 @@ lnet_startup_lndnis (void)
 
                 rc = (lnd->lnd_startup)(ni);
 
-                LNET_MUTEX_UP(&the_lnet.ln_lnd_mutex);
+                LNET_MUTEX_UNLOCK(&the_lnet.ln_lnd_mutex);
 
                 if (rc != 0) {
                         LCONSOLE_ERROR_MSG(0x105, "Error %d starting up LNI %s"
@@ -1251,7 +1251,7 @@ LNetNIInit(lnet_pid_t requested_pid)
         int         im_a_router = 0;
         int         rc;
 
-        LNET_MUTEX_DOWN(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_LOCK(&the_lnet.ln_api_mutex);
 
         LASSERT (the_lnet.ln_init);
         CDEBUG(D_OTHER, "refs %d\n", the_lnet.ln_refcount);
@@ -1322,7 +1322,7 @@ LNetNIInit(lnet_pid_t requested_pid)
  failed0:
         LASSERT (rc < 0);
  out:
-        LNET_MUTEX_UP(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_UNLOCK(&the_lnet.ln_api_mutex);
         return rc;
 }
 
@@ -1338,7 +1338,7 @@ LNetNIInit(lnet_pid_t requested_pid)
 int
 LNetNIFini()
 {
-        LNET_MUTEX_DOWN(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_LOCK(&the_lnet.ln_api_mutex);
 
         LASSERT (the_lnet.ln_init);
         LASSERT (the_lnet.ln_refcount > 0);
@@ -1361,7 +1361,7 @@ LNetNIFini()
                 lnet_unprepare();
         }
 
-        LNET_MUTEX_UP(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_UNLOCK(&the_lnet.ln_api_mutex);
         return 0;
 }
 
diff --git a/lnet/lnet/module.c b/lnet/lnet/module.c
index 7b7ffa5..4795a99 100644
--- a/lnet/lnet/module.c
+++ b/lnet/lnet/module.c
@@ -44,7 +44,7 @@ static int config_on_load = 0;
 CFS_MODULE_PARM(config_on_load, "i", int, 0444,
                 "configure network at module load");
 
-static cfs_semaphore_t lnet_config_mutex;
+static cfs_mutex_t lnet_config_mutex;
 
 int
 lnet_configure (void *arg)
@@ -52,7 +52,7 @@ lnet_configure (void *arg)
         /* 'arg' only there so I can be passed to cfs_create_thread() */
         int    rc = 0;
 
-        LNET_MUTEX_DOWN(&lnet_config_mutex);
+        LNET_MUTEX_LOCK(&lnet_config_mutex);
 
         if (!the_lnet.ln_niinit_self) {
                 rc = LNetNIInit(LUSTRE_SRV_LNET_PID);
@@ -62,7 +62,7 @@ lnet_configure (void *arg)
                 }
         }
 
-        LNET_MUTEX_UP(&lnet_config_mutex);
+        LNET_MUTEX_UNLOCK(&lnet_config_mutex);
         return rc;
 }
 
@@ -71,18 +71,18 @@ lnet_unconfigure (void)
 {
         int   refcount;
         
-        LNET_MUTEX_DOWN(&lnet_config_mutex);
+        LNET_MUTEX_LOCK(&lnet_config_mutex);
 
         if (the_lnet.ln_niinit_self) {
                 the_lnet.ln_niinit_self = 0;
                 LNetNIFini();
         }
 
-        LNET_MUTEX_DOWN(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_LOCK(&the_lnet.ln_api_mutex);
         refcount = the_lnet.ln_refcount;
-        LNET_MUTEX_UP(&the_lnet.ln_api_mutex);
+        LNET_MUTEX_UNLOCK(&the_lnet.ln_api_mutex);
 
-        LNET_MUTEX_UP(&lnet_config_mutex);
+        LNET_MUTEX_UNLOCK(&lnet_config_mutex);
         return (refcount == 0) ? 0 : -EBUSY;
 }
 
@@ -119,7 +119,7 @@ init_lnet(void)
         int                  rc;
         ENTRY;
 
-        cfs_init_mutex(&lnet_config_mutex);
+        cfs_mutex_init(&lnet_config_mutex);
 
         rc = LNetInit();
         if (rc != 0) {
diff --git a/lnet/lnet/router.c b/lnet/lnet/router.c
index b7d6c85..68757be 100644
--- a/lnet/lnet/router.c
+++ b/lnet/lnet/router.c
@@ -654,7 +654,7 @@ lnet_router_checker_event (lnet_event_t *event)
                 LASSERT (the_lnet.ln_rc_state == LNET_RC_STATE_UNLINKING);
                 the_lnet.ln_rc_state = LNET_RC_STATE_UNLINKED;
 #ifdef __KERNEL__
-                cfs_mutex_up(&the_lnet.ln_rc_signal);
+                cfs_up(&the_lnet.ln_rc_signal);
 #endif
                 return;
         }
@@ -970,7 +970,7 @@ lnet_router_checker_start(void)
                 return 0;
 
 #ifdef __KERNEL__
-        cfs_init_mutex_locked(&the_lnet.ln_rc_signal);
+        cfs_sema_init(&the_lnet.ln_rc_signal, 0);
         /* EQ size doesn't matter; the callback is guaranteed to get every
          * event */
         eqsz = 1;
@@ -1010,7 +1010,7 @@ lnet_router_checker_start(void)
                 rc = LNetMDUnlink(the_lnet.ln_rc_mdh);
                 LASSERT (rc == 0);
                 /* block until event callback signals exit */
-                cfs_mutex_down(&the_lnet.ln_rc_signal);
+                cfs_down(&the_lnet.ln_rc_signal);
                 rc = LNetEQFree(the_lnet.ln_rc_eqh);
                 LASSERT (rc == 0);
                 the_lnet.ln_rc_state = LNET_RC_STATE_SHUTDOWN;
@@ -1041,7 +1041,7 @@ lnet_router_checker_stop (void)
 
 #ifdef __KERNEL__
         /* block until event callback signals exit */
-        cfs_mutex_down(&the_lnet.ln_rc_signal);
+        cfs_down(&the_lnet.ln_rc_signal);
 #else
         while (the_lnet.ln_rc_state != LNET_RC_STATE_UNLINKED) {
                 lnet_router_checker();
diff --git a/lnet/selftest/conctl.c b/lnet/selftest/conctl.c
index 6602961..9ab1242 100644
--- a/lnet/selftest/conctl.c
+++ b/lnet/selftest/conctl.c
@@ -824,7 +824,7 @@ lstcon_ioctl_entry(unsigned int cmd, struct libcfs_ioctl_data *data)
                 return -EFAULT;
         }
 
-        cfs_mutex_down(&console_session.ses_mutex);
+        cfs_mutex_lock(&console_session.ses_mutex);
 
         console_session.ses_laststamp = cfs_time_current_sec();
 
@@ -908,7 +908,7 @@ lstcon_ioctl_entry(unsigned int cmd, struct libcfs_ioctl_data *data)
                              sizeof(lstcon_trans_stat_t)))
                 rc = -EFAULT;
 out:
-        cfs_mutex_up(&console_session.ses_mutex);
+        cfs_mutex_unlock(&console_session.ses_mutex);
 
         LIBCFS_FREE(buf, data->ioc_plen1);
 
diff --git a/lnet/selftest/conrpc.c b/lnet/selftest/conrpc.c
index 94074ae..65901d1 100644
--- a/lnet/selftest/conrpc.c
+++ b/lnet/selftest/conrpc.c
@@ -357,7 +357,7 @@ lstcon_rpc_trans_postwait(lstcon_rpc_trans_t *trans, int timeout)
                 lstcon_rpc_post(crpc);
         }
 
-        cfs_mutex_up(&console_session.ses_mutex);
+        cfs_mutex_unlock(&console_session.ses_mutex);
 
         cfs_waitq_wait_event_interruptible_timeout(trans->tas_waitq,
                                               lstcon_rpc_trans_check(trans),
@@ -365,7 +365,7 @@ lstcon_rpc_trans_postwait(lstcon_rpc_trans_t *trans, int timeout)
 
         rc = (rc > 0)? 0: ((rc < 0)? -EINTR: -ETIMEDOUT);
 
-        cfs_mutex_down(&console_session.ses_mutex);
+        cfs_mutex_lock(&console_session.ses_mutex);
 
         if (console_session.ses_shutdown)
                 rc = -ESHUTDOWN;
@@ -1117,10 +1117,10 @@ lstcon_rpc_pinger(void *arg)
         /* RPC pinger is a special case of transaction,
          * it's called by timer at 8 seconds interval.
          */
-        cfs_mutex_down(&console_session.ses_mutex);
+        cfs_mutex_lock(&console_session.ses_mutex);
 
         if (console_session.ses_shutdown || console_session.ses_expired) {
-                cfs_mutex_up(&console_session.ses_mutex);
+                cfs_mutex_unlock(&console_session.ses_mutex);
                 return;
         }
 
@@ -1205,7 +1205,7 @@ lstcon_rpc_pinger(void *arg)
         }
 
         if (console_session.ses_expired) {
-                cfs_mutex_up(&console_session.ses_mutex);
+                cfs_mutex_unlock(&console_session.ses_mutex);
                 return;
         }
 
@@ -1214,7 +1214,7 @@ lstcon_rpc_pinger(void *arg)
         ptimer->stt_expires = (cfs_time_t)(cfs_time_current_sec() + LST_PING_INTERVAL);
         stt_add_timer(ptimer);
 
-        cfs_mutex_up(&console_session.ses_mutex);
+        cfs_mutex_unlock(&console_session.ses_mutex);
 }
 
 int
@@ -1280,13 +1280,13 @@ lstcon_rpc_cleanup_wait(void)
                         cfs_waitq_signal(&trans->tas_waitq);
                 }
 
-                cfs_mutex_up(&console_session.ses_mutex);
+                cfs_mutex_unlock(&console_session.ses_mutex);
 
                 CWARN("Session is shutting down, "
                       "waiting for termination of transactions\n");
                 cfs_pause(cfs_time_seconds(1));
 
-                cfs_mutex_down(&console_session.ses_mutex);
+                cfs_mutex_lock(&console_session.ses_mutex);
         }
 
         cfs_spin_lock(&console_session.ses_rpc_lock);
diff --git a/lnet/selftest/console.c b/lnet/selftest/console.c
index 4eaf731..fab464b 100644
--- a/lnet/selftest/console.c
+++ b/lnet/selftest/console.c
@@ -1846,7 +1846,7 @@ lstcon_acceptor_handle (srpc_server_rpc_t *rpc)
 
         sfw_unpack_message(req);
 
-        cfs_mutex_down(&console_session.ses_mutex);
+        cfs_mutex_lock(&console_session.ses_mutex);
 
         jrep->join_sid = console_session.ses_id;
 
@@ -1905,7 +1905,7 @@ out:
         if (grp != NULL)
                 lstcon_group_put(grp);
 
-        cfs_mutex_up(&console_session.ses_mutex);
+        cfs_mutex_unlock(&console_session.ses_mutex);
 
         return rc;
 }
@@ -1941,7 +1941,7 @@ lstcon_console_init(void)
         console_session.ses_expired = 0;
         console_session.ses_laststamp = cfs_time_current_sec();   
 
-        cfs_init_mutex(&console_session.ses_mutex);
+        cfs_mutex_init(&console_session.ses_mutex);
 
         CFS_INIT_LIST_HEAD(&console_session.ses_ndl_list);
         CFS_INIT_LIST_HEAD(&console_session.ses_grp_list);
@@ -2000,7 +2000,7 @@ lstcon_console_fini(void)
 
         libcfs_deregister_ioctl(&lstcon_ioctl_handler);
 
-        cfs_mutex_down(&console_session.ses_mutex);
+        cfs_mutex_lock(&console_session.ses_mutex);
 
         srpc_shutdown_service(&lstcon_acceptor_service);
         srpc_remove_service(&lstcon_acceptor_service);
@@ -2010,7 +2010,7 @@ lstcon_console_fini(void)
 
         lstcon_rpc_module_fini();
 
-        cfs_mutex_up(&console_session.ses_mutex);
+        cfs_mutex_unlock(&console_session.ses_mutex);
 
         LASSERT (cfs_list_empty(&console_session.ses_ndl_list));
         LASSERT (cfs_list_empty(&console_session.ses_grp_list));
diff --git a/lnet/selftest/console.h b/lnet/selftest/console.h
index 48a4061..676f5d9 100644
--- a/lnet/selftest/console.h
+++ b/lnet/selftest/console.h
@@ -134,7 +134,7 @@ typedef struct lstcon_test {
 #define LST_CONSOLE_TIMEOUT     300             /* default console timeout */
 
 typedef struct {
-        cfs_semaphore_t         ses_mutex;      /* lock for session, only one thread can enter session */
+        cfs_mutex_t             ses_mutex;      /* lock for session, only one thread can enter session */
         lst_sid_t               ses_id;         /* global session id */
         int                     ses_key;        /* local session key */
         int                     ses_state;      /* state of session */
